controllers/EntradasController.php
<?php

namespace app\controllers;

use Yii;
use app\models\Entradas;
use yii\data\ActiveDataProvider;
use yii\web\Controller;
use yii\web\NotFoundHttpException;
use yii\filters\VerbFilter;

/**
 * EntradasController implements the CRUD actions for Entradas model.
 */
class EntradasController extends Controller
{
    /**
     * @inheritDoc
     */
    public function behaviors()
    {
        return array_merge(
            parent::behaviors(),
            [
                'verbs' => [
                    'class' => VerbFilter::className(),
                    'actions' => [
                        'delete' => ['POST'],
                    ],
                ],
            ]
        );
    }

    /**
     * Lists all Entradas models.
     *
     * @return string
     */
    public function actionIndex()
    {
        $dataProvider = new ActiveDataProvider([
            'query' => Entradas::find(),
            /*
            'pagination' => [
                'pageSize' => 50
            ],
            'sort' => [
                'defaultOrder' => [
                    'identrada' => SORT_DESC,
                ]
            ],
            */
        ]);

        return $this->render('index', [
            'dataProvider' => $dataProvider,
        ]);
    }

    /**
     * Displays a single Entradas model.
     * @param int $identrada Identrada
     * @return string
     * @throws NotFoundHttpException if the model cannot be found
     */
   
public function actionView($identrada)
{
    $model = $this->findModel($identrada);
    $editModel = new Entradas(); // Modelo para el formulario de edición

    if ($editModel->load(Yii::$app->request->post()) && $editModel->save()) {
        Yii::$app->session->setFlash('success', 'Entrada actualizada correctamente.');
        return $this->redirect(['view', 'identrada' => $editModel->identrada]);
    }

    return $this->render('view', [
        'model' => $model,
        'editModel' => $editModel,
    ]);
}


    /**
     * Creates a new Entradas model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     * @return string|\yii\web\Response
     */
    public function actionCreate()
    {
        $model = new Entradas();

        if ($model->load(Yii::$app->request->post()) && $model->save()) {
            Yii::$app->session->setFlash('success', 'Entrada guardada correctamente.');
            return $this->redirect(['view', 'identrada' => $model->identrada]);
        }

        return $this->render('entradasform', [
            'model' => $model,
        ]);
    }

    /**
     * Updates an existing Entradas model.
     * If update is successful, the browser will be redirected to the 'view' page.
     * @param int $identrada Identrada
     * @return string|\yii\web\Response
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionUpdate($identrada)
    {
        $model = $this->findModel($identrada);

        if ($this->request->isPost && $model->load($this->request->post()) && $model->save()) {
            return $this->redirect(['view', 'identrada' => $model->identrada]);
        }

        return $this->render('update', [
            'model' => $model,
        ]);
    }

  
    /**
 * Deletes an existing Entradas model.
 * If deletion is successful, the browser will be redirected to the 'diario' page.
 * @param int $identrada Identrada
 * @return \yii\web\Response
 * @throws NotFoundHttpException if the model cannot be found
 */
public function actionDelete($identrada)
{
    $model = $this->findModel($identrada);
    $model->delete();

    // Establecer un mensaje de confirmación
    Yii::$app->session->setFlash('success', 'Entrada eliminada correctamente.');

    return $this->redirect(['diario']);
}


    /**
     * Finds the Entradas model based on its primary key value.
     * If the model is not found, a 404 HTTP exception will be thrown.
     * @param int $identrada Identrada
     * @return Entradas the loaded model
     * @throws NotFoundHttpException if the model cannot be found
     */
    protected function findModel($identrada)
    {
        if (($model = Entradas::findOne(['identrada' => $identrada])) !== null) {
            return $model;
        }

        throw new NotFoundHttpException('The requested page does not exist.');
    }
    
  public function actionContinuar($identrada)
{
    // Redirige al formulario de creación de pensamientos y pasa el ID de la entrada como parámetro GET
    return $this->redirect(['pensamientos/create', 'identrada' => $identrada]);
}

public function actionDiario()
{
    return $this->render('diario');
}


public function actionCheckAndCreate()
{
    $today = date('Y-m-d');
    $existingEntry = Entradas::find()
        ->where(['fechaentrada' => $today])
        ->one();

    if ($existingEntry) {
        return $this->asJson(['exists' => true]);
    } else {
        return $this->asJson(['exists' => false]);
    }
}




}

controllers/SiteController.php
<?php

namespace app\controllers;

use Yii;
use yii\filters\AccessControl;
use yii\web\Controller;
use yii\web\Response;
use yii\filters\VerbFilter;
use app\models\LoginForm;
use app\models\ContactForm;
use app\models\Entradas;
use app\models\Objetivos;
use kartik\mpdf\Pdf;

class SiteController extends Controller {

    /**
     * {@inheritdoc}
     */
    public function behaviors() {
        return [
            'access' => [
                'class' => AccessControl::className(),
                'only' => ['logout'],
                'rules' => [
                    [
                        'actions' => ['logout'],
                        'allow' => true,
                        'roles' => ['@'],
                    ],
                ],
            ],
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'logout' => ['post'],
                ],
            ],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function actions() {
        return [
            'error' => [
                'class' => 'yii\web\ErrorAction',
            ],
            'captcha' => [
                'class' => 'yii\captcha\CaptchaAction',
                'fixedVerifyCode' => YII_ENV_TEST ? 'testme' : null,
            ],
        ];
    }

    /**
     * Displays homepage.
     *
     * @return string
     */
    public function actionIndex() {
        try {
            // Obtengo las entradas de diario más recientes en orden ascendente
            $entradas = \app\models\Entradas::find()->orderBy(['fechaentrada' => SORT_ASC])->limit(6)->all();
        } catch (\Exception $e) {
            Yii::error('Error al recuperar las entradas de diario: ' . $e->getMessage());
            $entradas = [];
        }

        // Llamo a la acción para contar las entradas positivas y negativas
        // $countResult = $this->actionGraficoEntradas();

        return $this->render('index', [
                    'entradas' => $entradas,
                        // 'positivas' => $countResult['positivas'],
                        // 'negativas' => $countResult['negativas'],
        ]);
    }

    /**
     * Login action.
     *
     * @return Response|string
     */
    public function actionLogin() {
        if (!Yii::$app->user->isGuest) {
            return $this->goHome();
        }

        $model = new LoginForm();
        if ($model->load(Yii::$app->request->post()) && $model->login()) {
            return $this->goBack();
        }

        $model->password = '';
        return $this->render('login', [
                    'model' => $model,
        ]);
    }

    /**
     * Logout action.
     *
     * @return Response
     */
    public function actionLogout() {
        Yii::$app->user->logout();

        return $this->goHome();
    }

    /**
     * Displays contact page.
     *
     * @return Response|string
     */
    public function actionContact() {
        $model = new ContactForm();
        if ($model->load(Yii::$app->request->post()) && $model->contact(Yii::$app->params['adminEmail'])) {
            Yii::$app->session->setFlash('contactFormSubmitted');

            return $this->refresh();
        }
        return $this->render('contact', [
                    'model' => $model,
        ]);
    }

    /**
     * Displays about page.
     *
     * @return string
     */
    public function actionAbout() {
        return $this->render('about');
    }

    /* mi primera explotacion de datos con los datos detallados de las ultimas 6 entradas del diario */

    public function actionView($id) {
        // Buscar la entrada por su ID
        $entrada = Entradas::findOne($id);

        // Verificar si la entrada existe
        if (!$entrada) {
            throw new \yii\web\NotFoundHttpException("La entrada con el ID $id no existe.");
        }

        //Cargar los pensamientos asociados a esta entrada
        $pensamientos = $entrada->getCodpens()->all();
        //cargar las emociones asociadas a esta entrada
        $emociones = $entrada->getCodemos()->all();

        $sensaciones = $entrada->getCodsensas()->all();

        return $this->render('vista_detalles', [
                    'entrada' => $entrada,
                    'pensamientos' => $pensamientos,
                    'sensaciones' => $sensaciones,
                    'emociones' => $emociones,
        ]);
    }

    /* Gráfica para obtener las últimas 6 entradas */

    public function actionGraficoEntradas() {
        try {
            // Obtener las entradas de diario más recientes
            $entradas = \app\models\Entradas::find()->orderBy(['fechaentrada' => SORT_ASC])->limit(6)->all();

            //cont para las entradas positivas y negativas
            $positivas = 0;
            $negativas = 0;
            //contar la cantidad de entradas positivas y negativas
            foreach ($entradas as $entrada) {
                $pensamientos = $entrada->getCodpens()->all();
                foreach ($pensamientos as $pensamiento) {
                    if ($pensamiento->positivo == 1) {
                        $positivas++;
                    } else {
                        $negativas++;
                    }
                }
            }
        } catch (\Exception $e) {
            Yii::error('Error al contar las entradas de diario: ' . $e->getMessage());
            $positivas = 0;
            $negativas = 0;
        }

        //retorno un arreglo asociativo con los conteos de entradas positivas y negativas 
        return [
            'positivas' => $positivas,
            'negativas' => $negativas,
        ];
    }

    public function actionInformacion() {

        return $this->render('informacion');
    }

    /* Conteo de pensamientos positivos y negativos(GRÁFICAS) */

    public function actionEstadisticas() {
        // Obtener el recuento de entradas positivas y negativas
        $countResult = $this->actionGraficoEntradas();

        // Renderizar la vista de estadísticas y pasar los datos del gráfico como parámetros
        return $this->render('estadisticas', [
                    'positivas' => $countResult['positivas'],
                    'negativas' => $countResult['negativas'],
        ]);
    }

    /* Lógica que cuenta los objetivos que estan completados y los que no estan completados (PARA LAS GRÁFICAS) */

    public function actionObjetivos() {
        try {
            // Obtener los objetivos más recientes
            $objetivos = Objetivos::find()->orderBy(['fechalimite' => SORT_DESC])->all();

            // Contadores para objetivos completados y no completados
            $completados = 0;
            $noCompletados = 0;

            // Contar la cantidad de objetivos completados y no completados
            foreach ($objetivos as $objetivo) {
                if ($objetivo->completado) {
                    $completados++;
                } else {
                    $noCompletados++;
                }
            }
        } catch (\Exception $e) {
            Yii::error('Error al contar los objetivos: ' . $e->getMessage());
            $completados = 0;
            $noCompletados = 0;
        }

        // Retornar un arreglo asociativo con los conteos de objetivos completados y no completados
        return [
            'completados' => $completados,
            'noCompletados' => $noCompletados,
        ];
    }

    public function actionSobremi() {
        return $this->render('sobremi');
    }

    /* Acción que renderiza los detalles de las entradas */

    public function actionVistaDetalles($fecha) {
        // Validar que la fecha no esté vacía
        if (empty($fecha)) {
            throw new \yii\web\BadRequestHttpException('Fecha no proporcionada.');
        }

        // Buscar la entrada por fecha
        $entrada = Entradas::findOne(['fechaentrada' => $fecha]);

        // Validar que la entrada exista
        if ($entrada === null) {
            throw new \yii\web\NotFoundHttpException('La entrada no existe.');
        }

        // Obtener los pensamientos asociados a esta entrada
        $pensamientos = $entrada->getCodpens()->all();
        // Obtener las emociones asociadas a esta entrada
        $emociones = $entrada->getCodemos()->all();
        // Obtener las sensaciones asociadas a esta entrada
        $sensaciones = $entrada->getCodsensas()->all();

        // Renderizar la vista con los detalles de la entrada, los pensamientos, las emociones y las sensaciones
        return $this->render('vista_detalles', [
                    'entrada' => $entrada,
                    'pensamientos' => $pensamientos,
                    'emociones' => $emociones,
                    'sensaciones' => $sensaciones,
        ]);
    }

    /* Lógica para la creación del PDF */

    public function actionDownloadPdf($id) {
        $entrada = Entradas::findOne($id);
        if (!$entrada) {
            throw new \yii\web\NotFoundHttpException("La entrada con el ID $id no existe.");
        }

        $pensamientos = $entrada->getCodpens()->all();
        $emociones = $entrada->getCodemos()->all();
        $sensaciones = $entrada->getCodsensas()->all();

        // Renderiza la vista para el PDF
        $content = $this->renderPartial('entrada-pdf', [
            'entrada' => $entrada,
            'pensamientos' => $pensamientos,
            'emociones' => $emociones,
            'sensaciones' => $sensaciones,
        ]);

        // Configuración del componente mPDF
        $pdf = new Pdf([
            'mode' => Pdf::MODE_UTF8,
            'format' => Pdf::FORMAT_A4,
            'orientation' => Pdf::ORIENT_PORTRAIT,
            'destination' => Pdf::DEST_BROWSER,
            'content' => $content,
            'options' => ['title' => 'Detalles de la Entrada'],
            'methods' => [
                'SetHeader' => ['Detalles de la Entrada'],
                'SetFooter' => ['{PAGENO}'],
            ],
        ]);

views/entradas/_form.php
<?php

use yii\helpers\Html;
use yii\widgets\ActiveForm;

/** @var yii\web\View $this */
/** @var app\models\Entradas $model */
/** @var yii\widgets\ActiveForm $form */
?>

<div class="entradas-form">

    <?php $form = ActiveForm::begin(); ?>

    <?= $form->field($model, 'titulo')->textInput(['maxlength' => true]) ?>

    <?= $form->field($model, 'descripcion')->textInput(['maxlength' => true]) ?>

    <?= $form->field($model, 'fechaentrada')->textInput() ?>

    <div class="form-group">
        <?= Html::submitButton('Save', ['class' => 'btn btn-success']) ?>
    </div>

    <?php ActiveForm::end(); ?>

</div>

views/entradas/create.php
<?php

use yii\helpers\Html;

/** @var yii\web\View $this */
/** @var app\models\Entradas $model */

$this->title = 'Create Entradas';
$this->params['breadcrumbs'][] = ['label' => 'Entradas', 'url' => ['index']];
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="entradas-create">

    <h1><?= Html::encode($this->title) ?></h1>

    <?= $this->render('_form', [
        'model' => $model,
    ]) ?>

</div>

views/entradas/diario.php
<?php
use app\models\Entradas;
use yii\helpers\Html;
use yii\helpers\Url;
use yii\web\View; 

/* @var $this yii\web\View */

$this->title = 'Diario';
$this->params['breadcrumbs'][] = $this->title;
$this->registerCssFile('@web/css/diario.css');

// Obtener todas las entradas
$entradas = Entradas::find()->all();
$fechasYTitulos = [];
foreach ($entradas as $entrada) {
    $fechasYTitulos[] = [
        'fecha' => date('Y-m-d', strtotime($entrada->fechaentrada)),
        'titulo' => $entrada->titulo,
        'descripcion' => $entrada->descripcion // Se añade la descripción
    ];
}
?>

<div class="site-diario">
    <div class="pagina-diario">
        <h1 class="titulo-diario">Diario</h1>
    </div>

    <div class="calendar-container">
        <div id="calendar"></div>
    </div>
</div>

<!-- Modal para mostrar detalles de la entrada -->
<div class="modal fade" id="entradaModal" tabindex="-1" role="dialog" aria-labelledby="entradaModalLabel" aria-hidden="true">
    <div class="modal-dialog" role="document">
        <div class="modal-content">
            <div class="modal-header">
                <h5 class="modal-title" id="entradaModalLabel">Detalles de la entrada</h5>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>
            </div>
            <div class="modal-body">
                <!-- Contenido de los detalles de la entrada -->
                <div id="entradaDetalle"></div>
            </div>
            <div class="modal-footer">
                <?= Html::button('Ver Detalles', [
                    'class' => 'btn btn-primary',
                    'id' => 'verDetallesBtn', // ID del botón
                ]) ?>
                <p>¡Gracias por leer! 😊</p>
            </div>
        </div>
    </div>
</div>

<script>
    // Pasar las fechas y títulos de PHP a JavaScript
    var fechasEntradas = <?php echo json_encode($fechasYTitulos); ?>;
</script>


<!-- Calendario -->
<script>
    document.addEventListener('DOMContentLoaded', function() {
        var verDetallesBtn = document.getElementById('verDetallesBtn');

        // Agregar un event listener al botón
        verDetallesBtn.addEventListener('click', function() {
            // Obtener la fecha de la entrada desde el atributo data-fecha del botón
            var fechaEntrada = this.getAttribute('data-fecha');
            if (fechaEntrada) {
                // Redirigir a la acción vistaDetalles con la fecha como parámetro
                window.location.href = '<?= Yii::$app->urlManager->createUrl(['site/vista-detalles', 'fecha' => '']) ?>' + fechaEntrada;
            } else {
                alert('Fecha no proporcionada.');
            }
        });

        var calendar = document.getElementById('calendar');
        var currentDate = new Date();
        var currentMonth = currentDate.getMonth();
        var currentYear = currentDate.getFullYear();

        function renderCalendar(month, year) {
            var firstDay = new Date(year, month, 1).getDay();
            var daysInMonth = new Date(year, month + 1, 0).getDate();
            var tbl = document.createElement('table');
            tbl.classList.add('calendar-table');

            var thead = document.createElement('thead');
            var daysRow = document.createElement('tr');
            var days = ['Lun', 'Mar', 'Mie', 'Jue', 'Vie', 'Sab', 'Dom'];
            for (var i = 0; i < days.length; i++) {
                var th = document.createElement('th');
                th.appendChild(document.createTextNode(days[i]));
                daysRow.appendChild(th);
            }
            thead.appendChild(daysRow);
            tbl.appendChild(thead);

            var tbody = document.createElement('tbody');
            var date = 1;
            for (var i = 0; i < 6; i++) {
                var row = document.createElement('tr');
                for (var j = 0; j < 7; j++) {
                    if (i === 0 && j < firstDay) {
                        var cell = document.createElement('td');
                        cell.appendChild(document.createTextNode(''));
                        row.appendChild(cell);
                    } else if (date > daysInMonth) {
                        break;
                    } else {
                        var cell = document.createElement('td');
                        var cellDate = year + '-' + (month + 1).toString().padStart(2, '0') + '-' + date.toString().padStart(2, '0');
                        var entrada = fechasEntradas.find(e => e.fecha === cellDate);
                        if (entrada) {
                            cell.style.backgroundColor = '#fbffc4';
                            cell.setAttribute('title', entrada.titulo);
                            cell.setAttribute('data-fecha', entrada.fecha);
                        }
                        cell.appendChild(document.createTextNode(date));

                        cell.addEventListener('click', function() {
                            var entradaDetalle = document.getElementById('entradaDetalle');
                            var cellDate = this.getAttribute('data-fecha');
                            var entrada = fechasEntradas.find(e => e.fecha === cellDate);
                            if (entrada) {
                                var formattedDate = new Date(cellDate).toLocaleString('es-ES', { day: '2-digit', month: 'long', year: 'numeric' });

                                // Crear un div temporal para decodificar HTML
                                var tempDiv = document.createElement('div');
                                tempDiv.innerHTML = entrada.descripcion;
                                var descripcionDecodificada = tempDiv.textContent || tempDiv.innerText || '';

                                // Limitar título y descripción a 30 caracteres
                                var tituloCortado = entrada.titulo.length > 30 ? entrada.titulo.substring(0, 30) + '...' : entrada.titulo;
                                var descripcionCortada = descripcionDecodificada.length > 30 ? descripcionDecodificada.substring(0, 30) + '...' : descripcionDecodificada;

                                entradaDetalle.innerHTML = '<strong>Fecha:</strong> ' + formattedDate + '<br><strong>Título:</strong> ' + tituloCortado + '<br><strong>Descripción:</strong> ' + descripcionCortada;
                                var verDetallesBtn = document.getElementById('verDetallesBtn');
                                verDetallesBtn.setAttribute('data-fecha', entrada.fecha);
                                $('#entradaModal').modal('show');
                            }
                        });

                        if (date === currentDate.getDate() && month === currentDate.getMonth() && year === currentDate.getFullYear()) {
                            cell.style.backgroundColor = '#e6d7f6';
                            cell.style.color = '#B65598';
                            cell.classList.add('current-day');
                        }
                        row.appendChild(cell);
                        date++;
                    }
                }
                tbody.appendChild(row);
            }
            tbl.appendChild(tbody);

            var nav = document.createElement('div');
            nav.classList.add('calendar-nav');

            var prevBtn = document.createElement('button');
            prevBtn.innerHTML = '&lt;';
            prevBtn.addEventListener('click', function() {
                currentMonth--;
                if (currentMonth < 0) {
                    currentMonth = 11;
                    currentYear--;
                }
                renderCalendar(currentMonth, currentYear);
            });

            var nextBtn = document.createElement('button');
            nextBtn.innerHTML = '&gt;';
            nextBtn.addEventListener('click', function() {
                currentMonth++;
                if (currentMonth > 11) {
                    currentMonth = 0;
                    currentYear++;
                }
                renderCalendar(currentMonth, currentYear);
            });

            var title = document.createElement('div');
            title.classList.add('calendar-title');
            title.innerHTML = new Date(year, month).toLocaleString('es-ES', { month: 'long', year: 'numeric' });

            nav.appendChild(prevBtn);
            nav.appendChild(title);
            nav.appendChild(nextBtn);

            calendar.innerHTML = '';
            calendar.appendChild(nav);
            calendar.appendChild(tbl);
        }

        renderCalendar(currentMonth, currentYear);
    });
</script>

<script>
    document.addEventListener('DOMContentLoaded', function() {
        // Selecciona todos los elementos td con atributo title
        var cellsWithTitle = document.querySelectorAll('.calendar-table td[title]');

        // Itera sobre cada elemento y agrega un event listener para el evento mouseover
        cellsWithTitle.forEach(function(cell) {
            cell.addEventListener('mouseover', function() {
                // Obtén el título y trunca el texto si supera los 20 caracteres
                var title = this.getAttribute('title');
                var truncatedTitle = title.length > 20 ? title.substring(0, 20) + '...' : title;

                // Establece el atributo title truncado
                this.setAttribute('title', truncatedTitle);
            });
        });
    });
</script>

views/entradas/entradasform.php
<?php

use yii\helpers\Html;
use yii\widgets\ActiveForm;
use yii\helpers\Url;
use mihaildev\ckeditor\CKEditor; // Importar la clase CKEditor

/* @var $this yii\web\View */
/* @var $model app\models\Entradas */
/* @var $form yii\widgets\ActiveForm */
$this->registerCssFile(Url::to('@web/css/entradasForm.css'));
?>

<div class="row">
    <div class="col-md-6"> 
        <div class="page-title">
            <h1>¿Cómo estás?</h1>
        </div>
        
        <div class="entradas-form">
            <!-- Agregar bloque para mostrar mensaje flash -->
            <?php if (Yii::$app->session->hasFlash('success')): ?>
                <div class="alert alert-success">
                    <?= Yii::$app->session->getFlash('success') ?>
                </div>
            <?php endif; ?>

            <?php $form = ActiveForm::begin(); ?>

            <?= $form->field($model, 'titulo')->textInput(['maxlength' => true, 'placeholder' => 'Ingrese un título (máx. 100 caracteres)','maxlength' => 100]) ?>

            <?= $form->field($model, 'descripcion')->widget(CKEditor::class, [
                'editorOptions' => [
                    'preset' => 'standard',
                    'inline' => false,
                    'placeholder' => 'Detalla tu día (máx. 2500 caracteres)', // Agregar el placeholder
                ],
            ])->label(false) ?>

            <?= $form->field($model, 'fechaentrada')->textInput(['type' => 'date', 'value' => date('Y-m-d'), 'readonly' => true]) ?>

            <div class="form-group">
                <?= Html::submitButton('Guardar', ['id' => 'guardar-btn', 'class' => 'btn btn-success']) ?>
            </div>

            <?php ActiveForm::end(); ?>
        </div>
    </div>
    <div class="col-md-6">
        <img src="<?= Url::to('@web/images/diario2.png') ?>" alt="Diario" class="imagen-formulario">
    </div>
</div>

<div id="popup-confirmacion" class="popup" style="display: none;">
    <div class="popup-tarjeta">
        <div class="popup-contenido">
            <p>¿Está seguro de que desea guardar?</p>
            <div class="opciones">
                <button id="confirmar-guardar" class="btn-primary">Guardar</button>
                <button id="cancelar-guardar" class="btn-danger">Cancelar</button>
            </div>
        </div>
    </div>
</div>

<?php
$this->registerJsFile('@web/js/confirmation.js', ['depends' => [\yii\web\JqueryAsset::class]]);
?>

<?php
// JavaScript para limitar la cantidad de caracteres en CKEditor
$this->registerJs("
    $(document).ready(function(){
        var editor = CKEDITOR.instances['" . Html::getInputId($model, 'descripcion') . "'];

        editor.on('change', function() {
            var text = editor.getData();
            var decodedText = $('<div/>').html(text).text(); // Decodificar HTML entities
            var maxLength = 2500;
            if (decodedText.length > maxLength) {
                var newText = decodedText.substring(0, maxLength);
                editor.setData(newText);
            }
        });
    });
");
?>

views/entradas/index.php
<?php

use app\models\Entradas;
use yii\helpers\Html;
use yii\helpers\Url;
use yii\grid\ActionColumn;
use yii\grid\GridView;

/** @var yii\web\View $this */
/** @var yii\data\ActiveDataProvider $dataProvider */

$this->title = 'Entradas';
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="entradas-index">

    <h1><?= Html::encode($this->title) ?></h1>

    <p>
        <?= Html::a('Create Entradas', ['create'], ['class' => 'btn btn-success']) ?>
    </p>


    <?= GridView::widget([
        'dataProvider' => $dataProvider,
        'columns' => [
            ['class' => 'yii\grid\SerialColumn'],

            'identrada',
            'titulo',
            'descripcion',
            'fechaentrada',
            [
                'class' => ActionColumn::className(),
                'urlCreator' => function ($action, Entradas $model, $key, $index, $column) {
                    return Url::toRoute([$action, 'identrada' => $model->identrada]);
                 }
            ],
        ],
    ]); ?>


</div>

views/entradas/update.php
<?php

use yii\helpers\Html;

/** @var yii\web\View $this */
/** @var app\models\Entradas $model */

$this->title = 'Update Entradas: ' . $model->identrada;
$this->params['breadcrumbs'][] = ['label' => 'Entradas', 'url' => ['index']];
$this->params['breadcrumbs'][] = ['label' => $model->identrada, 'url' => ['view', 'identrada' => $model->identrada]];
$this->params['breadcrumbs'][] = 'Update';
?>
<div class="entradas-update">

    <h1><?= Html::encode($this->title) ?></h1>

    <?= $this->render('_form', [
        'model' => $model,
    ]) ?>

</div>